package review.calculateur.strategy;

import java.util.Scanner;

/**
 * Application principale pour le calculateur. 
 * la lecture de l'entree est faite dans l'application principale
 * la definition des operateurs possibles aussi
 * @author kirsch
 */
public class AppliCalculette {
    /**
     * lecture de l'entree a partir du clavier
     * @param mesg message affiche a l'utilisateur
     * @return valeur lu
     */
    public int readInt (String mesg) { 
        Scanner in = new Scanner(System.in);
        System.out.println(mesg);
        return in.nextInt();
    }
    
    public String readString (String mesg) { 
        Scanner in = new Scanner(System.in);
        System.out.println(mesg);
        return in.next();
    }
    
    Calculator c;
    
    public AppliCalculette() {
        c = new Calculator();
        c.addOperation("+", new Addition());
        c.addOperation("-", new Soustraction());
        c.addOperation("*", new Multiplication());
        c.addOperation("/", new Division());
    }
    
    public int calculer () {
        int a = readInt("a ? ");
        int b = readInt("b ? ");
        String op = readString("op ?");
        
        c.init(a, b, op);
        return c.calc();
    }
    
    public static void main (String args[]) {
        AppliCalculette m = new AppliCalculette();
        int r = m.calculer();
        System.out.println("Result ? "+r);
    }    
    
}
