package review.calculateur.strategy;

import java.util.HashMap;
import java.util.Map;


/**
 * Exemple de classe extensible.
 * On peut facilement etendre les fonctionnalites de la classe Calculator
 * en lui ajoutant un nouvel operateur, associe a un symbole. 
 * @author kirsch
 * @see Operation
 */
public class Calculator {
    Map<String, Operation> operations; //operations possibles
    int a, b; //operands
    String op;  //operateur
    
    public Calculator (){
        this.operations = new HashMap<String, Operation>();
    }
    
    public void addOperation (String sym, Operation op) {
        this.operations.put(sym, op);
    }
    
    public void init (int a, int b, String op) {
        this.a = a;
        this.b = b;
        this.op = op;
    }
    
    public int calc () {
        int r = 0;
        Operation o = this.operations.get(this.op);
        if (o!=null) { //operation definie
            r = o.execute(a, b);
        }
        else { 
            //l'idéal ici aurait été de lancer une exception
            System.out.println("Opération inconnue");
        }
        return r;
    }
}
