/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.exceptions;

import java.util.InputMismatchException;
import java.util.Scanner;

/**
 * Exemple de capture d'une exception. L'exception capturée est une
 * InputMismatchException qui est levée lorsque l'utilisateur n'entre pas
 * un numéro entier, comme il est demandé.
 * @link InputMismatchException
 * @author Manuele Kirsch Pinheiro <kirschpm@gmail.com>
 */
public class ExempleException {
    
   /**
     * méthode faisant la lecture à partir du clavier d'un numéro entier.
     * @param mesg message à afficher avant la lecture
     * @return numéro entier renseigné par l'utilisateur
     * @throws InputMismatchException peut être lancée si l'entrée ne correspond pas à un entier
     */ 
    public int lecture(String mesg) throws InputMismatchException {
       Scanner sc = new Scanner(System.in);
       System.out.print(mesg);
       return sc.nextInt();
   }  
   
   public int somme() {
       int a,b,r;
       
       a = lecture("a ?");
       b = lecture("b ?");
       r = a + b;
       
       return r; 
   }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        ExempleException exe = new ExempleException();
        int somme;
        
        try {
            somme = exe.somme();
            System.out.println("somme : "+somme);
        } catch (InputMismatchException ime) {
            System.out.println("Impossible de calculer la somme");
            ime.printStackTrace(System.out);
        }
    }
}
