/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.exercices;

import java.util.Iterator;
import review.business.*;

/**
 *
 * @author kirsch
 */
public class DepartmentTest1 {

    private Department dept;
    
    private TextUI ui;

    public DepartmentTest1(String name) {
        this.dept = new Department(name);
        this.ui = new TextUI();
    }

    public DepartmentTest1() {
        this("");
    }

    /* puisque dept est privée, il faut lui donner un getter et un setter
     * pour que les sous-classes puissent y accèder
     */
    public Department getDept() {
        return dept;
    }

    public void setDept(Department dept) {
        this.dept = dept;
    }
    
    /*
     * idem pour TextUI : on peut changer donc l'interface sans se faire trop de soucis
     */
    public TextUI getUi() {
        return ui;
    }

    public void setUi(TextUI ui) {
        this.ui = ui;
    }

    /**
     * creer un nouveau employee et l'additionne au departement
     */
    public void newEmployee () {
        Employee e = new Employee();
        readEmployee(e);
        this.dept.addEmployee(e);
    }


    public void newManager () {
        Manager m = new Manager();
        readManager(m);
        this.dept.addEmployee(m);
        this.dept.setManager(m);
    }


    protected void readManager (Manager m) { 
        readEmployee(m);
        m.setBonus(ui.readFloat("Bonus: ")); 
    }


    protected void readEmployee (Employee e) {
        e.setName(ui.readString("Name: "));
        e.setSalary(ui.readFloat("Salary: "));
        e.setHireDay(ui.readDate("Hire Year: ", "Hire month (1-12): ", "Hire day: "));
    }

    
    /**
     * augmente tous les salaires
     */
    public void raiseSalary () {
        float perc = this.readPercentual();
        this.dept.raiseAllSalaries(perc);
    }


    protected float readPercentual () {
        float perc = ui.readFloat("Raise up percentual (0,xx): ");
        return perc;
    }


    /** 
     * affiche les informations concernant le departement, ainsi que ses membres
     */
    public void print () {
        ui.showMessage("Dept "+this.dept.getName());
        ui.showMessage("Manager ");
        this.printManager(this.dept.getManager());

        ui.showMessage("Employees ");
        Iterator<Employee> membres = this.dept.employees();
        while (membres.hasNext()) {
            this.printEmployee(membres.next());
        }
    }


    protected void printEmployee (Employee e) {
        ui.showMessage("Name: " + e.getName());
        ui.showMessage("Salary: " + e.getSalary());
        ui.showMessage("Hire date: " + e.getHireDay());
    }

    protected void printManager (Manager m) {
        printEmployee(m);
        ui.showMessage("Bonus: " + m.getBonus());
    }

    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        DepartmentTest1 test = new DepartmentTest1("Testing Dept");

        test.newEmployee();
        test.newManager();
        test.raiseSalary();
        test.print();
    }

}
