/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.exercices;

import java.util.ArrayList;
import java.util.List;

/**
 * Implementation de l'interface Pile
 * Objectif : usage interface, structure de donnees Stack, collections
 * @author kirsch
 */
public class MaPile<T> implements Pile<T> {
    //structure concrete
    List<T> mpile;

    //haut de la pile correspond a la position 0
    static final int HAUT = 0;

    public MaPile() {
        this.mpile = new ArrayList<T>();
    }
        
    /** retirer et retourner l'element en haut de la pile */
    public T pop() {
        //on recupere le haut de la pile et on l'efface
        T o = this.mpile.get(HAUT);
        this.mpile.remove(HAUT);
        return o;
    }

    /** ajouter un nouveau element en haut de la pile */
    public void push(T obj) {
        //on ajoute en position HAUT
        this.mpile.add(HAUT, (T)obj);
    }

    public boolean isEmpty() {
        return this.mpile.isEmpty();
    }

}
