/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.exercices.business;

import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import javax.swing.JOptionPane;

/**
 *
 * @author Manuele Kirsch Pinheiro <kirschpm@gmail.com>
 */
public class NoListenerFormEmployee extends AbstractNoListenerDepartmentView {
    //Action commands pour les boutons

    public static final String OK_COMMAND = "OK";
    public static final String REMOVE_COMMAND = "Remove";
    public static final String NAME_FIELD = "Name";
    public static final String SALARY_FIELD = "Salary";
    public static final String HIRE_DATE_FIELD = "Hire Date";
    //variables
    private javax.swing.JLabel HireDateLabel = new javax.swing.JLabel();
    private javax.swing.JTextField HireDDText = new javax.swing.JTextField();
    private javax.swing.JTextField HireMMText = new javax.swing.JTextField();
    private javax.swing.JTextField HireYYYText = new javax.swing.JTextField();
    private javax.swing.JLabel NameLabel = new javax.swing.JLabel();
    private javax.swing.JTextField NameText = new javax.swing.JTextField();
    private javax.swing.JLabel SalaryLabel = new javax.swing.JLabel();
    private javax.swing.JTextField SalaryText = new javax.swing.JTextField();
    private javax.swing.JButton OkButton = new javax.swing.JButton();
    private javax.swing.JButton RemoveButton = new javax.swing.JButton();

    public NoListenerFormEmployee(ListenerDepartmentControler control) {
        super(control);
        initComponents();
        this.setupListeners(null, control);
    }

    @Override
    protected void setupListeners(ListenerDepartmentControler oldone,
            ListenerDepartmentControler newone) {

        if (oldone != null) {
            this.OkButton.removeActionListener(oldone);
            this.RemoveButton.removeActionListener(oldone);
        }
        if (newone != null) {
            this.OkButton.addActionListener(this.getDepartmentControler());
            this.RemoveButton.addActionListener(this.getDepartmentControler());
        }

    }

    protected void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        NameLabel.setText(NAME_FIELD);
        getContentPane().add(NameLabel, new java.awt.GridBagConstraints());

        NameText.setColumns(35);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(NameText, gridBagConstraints);

        SalaryLabel.setText(SALARY_FIELD);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        getContentPane().add(SalaryLabel, gridBagConstraints);

        SalaryText.setColumns(10);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(SalaryText, gridBagConstraints);

        HireDateLabel.setText(HIRE_DATE_FIELD);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        getContentPane().add(HireDateLabel, gridBagConstraints);

        HireDDText.setText("DD");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(HireDDText, gridBagConstraints);

        HireMMText.setText("MM");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(HireMMText, gridBagConstraints);

        HireYYYText.setText("YYYY");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(HireYYYText, gridBagConstraints);


        OkButton.setText(OK_COMMAND);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(OkButton, gridBagConstraints);

        RemoveButton.setText(REMOVE_COMMAND);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        getContentPane().add(RemoveButton, gridBagConstraints);

        pack();
    }

    protected Date handleDate() throws NumberFormatException {
        Calendar cal = Calendar.getInstance();
        cal.set(Integer.parseInt(this.HireYYYText.getText()),
                Integer.parseInt(this.HireMMText.getText()),
                Integer.parseInt(this.HireDDText.getText()));
        return cal.getTime();
    }

    protected Float handleSalary() throws NumberFormatException {
        return Float.valueOf(this.SalaryText.getText());
    }

    /**
     * @return Has avec les champs du formulaire, uniquement s'ils sont
     * correctement remplis, un hash vide dans le cas contraire
     */
    public HashMap<String, Object> getFieldData() {
        HashMap<String, Object> fields = new HashMap<>();
        try {
            fields.put(NAME_FIELD, this.NameText.getText());
            fields.put(SALARY_FIELD, this.handleSalary());
            fields.put(HIRE_DATE_FIELD, this.handleDate());
        } catch (NumberFormatException nfe) {
            fields.clear();
            this.showErrorMessage("Invalid hire date or salary values");
        }
        
        return fields;
    }

    public void setFields(String nameField, Float salaryField, Date hireDateField) {
        Calendar cal = Calendar.getInstance();
        cal.setTime(hireDateField);

        this.NameText.setText(nameField);
        this.SalaryText.setText(salaryField.toString());
        this.HireDDText.setText(Integer.toString(cal.get(Calendar.DAY_OF_MONTH)));
        this.HireMMText.setText(Integer.toString(cal.get(Calendar.MONTH)));
        this.HireYYYText.setText(Integer.toString(cal.get(Calendar.YEAR)));

    }

    public void showErrorMessage(String message) {
        JOptionPane.showMessageDialog(this, message, "Alert", JOptionPane.ERROR_MESSAGE);
    }
}
