/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.exercices.business;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Iterator;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

/**
 *
 * @author Manuele Kirsch Pinheiro <kirschpm@gmail.com>
 */
public class NoListenerListEmployees extends AbstractNoListenerDepartmentView {

    private JList employeeList;
    private DefaultListModel<String> data;

    public NoListenerListEmployees(ListenerDepartmentControler control) {
        super(control);
        initComponents();
        this.setupListeners(null, control);
    }

    public String getSelectedEmployee() {
        String name = "";
        int index = this.employeeList.getSelectedIndex();
        if (index >= 0) {
            name = this.data.elementAt(index);
        }
        return name;
    }

    @Override
    protected void setupListeners(ListenerDepartmentControler oldone,
            ListenerDepartmentControler newone) {
        //on supprime les anciens listeners
        if (oldone != null) {
            this.employeeList.removeListSelectionListener(oldone);
        }
        if (newone != null) {
            this.employeeList.addListSelectionListener(newone);
        }
    }

    @Override
    protected void initComponents() {
        this.data = new DefaultListModel<String>();
        this.employeeList = new JList(data);
        this.employeeList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        JScrollPane scrollPane = new JScrollPane(this.employeeList);
        this.add(scrollPane);
        this.loadNames();
    }

    //mise a jour de noms de maniere tres idiote
    public void loadNames() {
        java.util.List<String> employeeUpdated = this.getDepartmentControler().getEmployeeNames();
        
        //nettoie la liste et on remplace ses éléments
        this.data.clear();
        for (String aName : employeeUpdated) {
            this.data.addElement(aName);
        }
        pack();
        repaint();
    }
}
