/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.exercices.mvc;

import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/**
 *
 * @author kirsch
 */
public abstract class AbstractVolumeView extends Frame implements VolumeView {

    private VolumeControler control;

    public AbstractVolumeView(VolumeControler control) {
        this.control = control;
        this.initWindowListener();
    }

    private void initWindowListener() {
        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                control.closeViews();
            }
        });
    }

    public void setVolumeControler(VolumeControler control) {
        this.control = control;
    }

    public VolumeControler getVolumeControl() {
        return this.control;
    }

    public void display() {
        this.setVisible(true);
    }

    @Override
    public void hide() {
        this.setVisible(false);
    }

    //public void volumeChanged(VolumeEvent evt);
}
