package review.heritage;

/**
 * Exemple de réduction du couplace grâce à l'usage des interfaces
 * La classe ControlDevice peut contrôler n'importer quel type de Door
 * puisqu'elle ne compte qu'une référence à l'interface et pas aux classes concrètes
 * @author Manuele Kirsch Pinheiro <kirschpm@gmail.com>
 */
public class ControlDevice {
     private Door door;

     public ControlDevice() {
         
     }

    public Door getDoor() {
        return door;
    }

    public void setDoor(Door d) {
        this.door = d;
    }
     
    public void pressButtonA() {
          door.open();
    }

     public void pressButtonB() {
          door.close();
     }
}