package review.heritage;

public class MultiplyClass extends AddClass {

    @Override
    public float calcul() {
        return this.getA() * this.getB();
    }

    public float calcul(float par) {
        return par * super.calcul();
    }   
    
    //Java considère ça comme une surcharge (paramètre + spécifique)
    //l'annotation @Override transformera la déclaration en erreur
    //@Override 
    public void copy(MultiplyClass m) {
        super.copy((AddClass)m);
    }
    
    //Java considère ça comme une redéfinition
    //puisque le type de retour est + spécialisé
    @Override
    public MultiplyClass getInstance() {
        MultiplyClass m = new MultiplyClass();
        m.setA(this.getA());
        m.setB(this.getB());
        return m;
    }
    
}