/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.patterns.strategy;

import java.util.Scanner;

/**
 * Exemple illustrant l'usage du pattern strategy
 * @author Manuele Kirsch Pinheiro <kirschpm@gmail.com>
 */
public class ClientSortMain {

    public static SortStrategy choixStrategy(String s) {
        SortStrategy strategy = null;
        
        switch (s) {
            case "s":
            case "S":
                strategy = new SelectionSort();
                break;
            case "b":
            case "B":
                strategy = new BubbleSort();
                break;
      //on peut ajouter très facilement des nouvelles stratégies
      /*    case "M":
            case "m":
                strategy = new TrieManu();
                break;
        */ 
            default:
                strategy = new QuickSort();
        }
        
        return strategy;
    }
    
    public static void sort(SortStrategy strategy) {
        SortArray sort = new SortArray();
        double[] data = { 5, 1, 12, -5, 16, 2, 12, 14 };
        
        showData(data);
        
        sort.setSortStrategy(strategy);
        sort.sort(data);
        
        showData(data);
    }
    
    
    public static void showData(double[] data) {
        System.out.print("{ ");
        for (double d: data) {
            System.out.print(d+" ");
        }
        System.out.println("}");
    }
    
    
    public static void main(String[] args) {
        SortStrategy strategy = null;
        Scanner sc = new Scanner(System.in);
        String choix;
        
        System.out.print("Strategy (Q=Quick, B=Bubble, S=Selection) ?");
        choix = sc.nextLine();
        
        strategy = choixStrategy(choix);
        sort(strategy);
    }
}
